Copyright RadioToolBox.com  another great application from Jay Krivanek<br>
<?php

// If register globals is off, then we get are vars this way.
if (isset($_REQUEST)) {
    while(list($varname, $varvalue) = each($_REQUEST)) { $$varname = $varvalue; }
}
if (isset($_SERVER)) { 
    while (list($varname, $varvalue) = each($_ENV)) { $$varname = $varvalue; }
    while (list($varname, $varvalue) = each($_SERVER)) { $$varname = $varvalue; }
}

include("config.php");

function rtb_log($str)
{
	global $enable_error_log, $includes_path;
	if ($enable_error_log == true)
	{
		$fp = @fopen($includes_path."error_log.txt", "a");
		if ($fp)
		{
			fwrite($fp, date("m/d/Y@H:i:s").": ".$str."\r\n");
			fclose($fp);
		}
	}
}

function console_out($str)
{
	echo $str."\r\n";
	flush();
}

// Addslashes (if nessacary) and fix any characters (&,<,>,etc.) that may break stuff down the road.

for($i=0; $i<count($server); $i++){
	for($j=0; $j<count($server[$i]); $j++){
		if (!get_magic_quotes_gpc()){
			$server[$i][$j]=addslashes($server[$i][$j]);
		}
				//$server[$i][$j]=htmlspecialchars($server[$i][$j], ENT_QUOTES);
	}
}
	$other_variables=array('tit', 'l', 'ml', 'ti');
	for($i=0; $i<count($other_variables); $i++){
		if (!get_magic_quotes_gpc()){
			$$other_variables[$i]=addslashes($$other_variables[$i]);
		}
		//$$other_variables[$i]=htmlspecialchars($$other_variables[$i], ENT_QUOTES);
	}

// First Let's check our environment
if (getenv("REQUEST_METHOD") != "POST")
{
	if ($debug == $rtb_user)
	{
		console_out("<PRE>");
		console_out("Welcome to the RTB Catcher Debug Session");
		console_out("We will now check your server environment for proper installation and compatibility with catcher.");
		console_out("Now letting you read this message cause we can.");
		Sleep(1);
		console_out("Starting Check...");
		console_out("Checking Environment...");
		if ($includes_path == "")
		{
        	console_out("the \$includes_path is not set therefore we will be working in the directory: ".getcwd());
		}
		console_out("Checking for proper file permissions");
		if ($enable_error_log == true && !is_writable($includes_path."error_log.txt"))
		{
			console_out("Warning: Log file error_log.txt is not writable or does not exist.");
		}
		if (file_exists($includes_path."includes.php"))
		{
			console_out("Wonderful, includes.php exists, now we will use our nunchuck ninja magic on it to see if we can do anything with it.");
		}
		else
		{
			console_out("Warning: includes.php does not exist in the proper location, this makes me sad, attempting to create...");
			if ($inc = @fopen($includes_path."includes.php", "w"))
			{
				console_out("Whew, you can thank me cause I saved you the trouble of creating this file yourself... :)");
				fclose($inc);
			}
			else
			{
				console_out("FATAL ERROR: We suck, the file ".$includes_path."includes.php could not be created, make sure I have permission to do so or create this file yourself that gives me read write access.");
				exit;
			}
		}
		if (is_writable($includes_path."includes.php"))
		{
			console_out("The includes file is writable lucky us.");
		}
		else
		{
			console_out("FATAL ERROR: includes.php is not writable by us, check to ensure that the user Apache runs under has access to this file and or directory.");
		}			
		exit;
	}
	else
	{
		console_out("well if you see this then php is installed and catcher can at least be parsed, maybe try debugging me by adding ?debug=USERNAME in the url field");
		exit;
	}
}
	
if ((!$pass || !$user) && getenv("REQUEST_METHOD") == "POST")
{
	rtb_log("No User or Password Sent");
	exit;
}

// Verify that info is from trusted source.

if ($pass != $rtb_pass || $user != $rtb_user)
{
	rtb_log("Bad Password from: ".getenv("REMOTE_ADDR"));
	echo 'BADPASSWORD';
	exit;
}


if($mode=="flat_file"){

	$list_size = count($server);
	@include($includes_path."includes.php");

	$data="<?php\r\n";

	for($i=0; $i<$list_size; $i++){

		$server_vars=array('ip', 'type', 'listeners', 'max_listeners', 'bitrate', 'status', 'desc', 'current_song');

		for($j=0; $j<count($server_vars); $j++){

			$data.="\$server[$i]['$server_vars[$j]']=";

			$data.='\''.$server[$i][$j].'\';';

			$data.="\r\n";

			$rtb_array[$i][$server_vars[$j]] = $server[$i][$j];

		}

	}

	$data.="\r\n";

	$total_var_name=array('current_song', 'listeners', 'max_listeners', 'touch_interval');

	$total_var_var=array('tit', 'l', 'ml', 'ti');

	for($j=0; $j<count($total_var_name); $j++){

		$data.="\$$total_var_name[$j]='${$total_var_var[$j]}';\r\n";

		$rtb_array['default'][$total_var_name[$j]] = $$total_var_var[$j];

	}

	

	if(("$tit"==addslashes($lastsong[0])) || ($tit=='')){

		$offset=0;

		$lastsong_rep[0]=addslashes($lastsong[0]);

		$lasttime_rep[0]=$lasttime[0];

	}

	else{

		$offset=1;

		$lastsong_rep[-1]=$tit;

		$lasttime_rep[-1]=round(time()-$time_zone*3600);

	}

	for($j=0; $j<$song_history; $j++){

		$replace_num=$j-$offset;

		if($j>0){

			$lastsong_rep[$replace_num]=addslashes($lastsong[$replace_num]);

			$lasttime_rep[$replace_num]=$lasttime[$replace_num];

		}

		$data.="\$lastsong[$j]='$lastsong_rep[$replace_num]';\r\n\$lasttime[$j]='$lasttime_rep[$replace_num]';\r\n";



	}	

	

	$data.="?>";

	$fp = fopen($includes_path."includes.php", "w");

	fwrite($fp, $data);

	fclose($fp);

}
else if($mode=="db_mysql"){

// no deal, real soon I would suspect
}

?>